#pragma once


class CMainFrame : public CFrameWnd
{
public:
//Constructors / Destructors
  CMainFrame(const CMainFrame&) = delete;
  CMainFrame(CMainFrame&&) = delete;
  ~CMainFrame() = default; //NOLINT(modernize-use-override)

//Methods
  CMainFrame& operator=(const CMainFrame&) = delete;
  CMainFrame& operator=(CMainFrame&&) = delete;
#ifdef _DEBUG
  void AssertValid() const override;
  void Dump(CDumpContext& dc) const override;
#endif

protected:
//Constructors / Destructors
  CMainFrame() noexcept;

//Methods
  BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) override;

//Member variables
  CSplitterWnd m_wndSplitter;
  CStatusBar m_wndStatusBar;
  CToolBar m_wndToolBar;

//Message handlers
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg BOOL OnDeviceChange(UINT nEventType, DWORD_PTR dwData);

  DECLARE_MESSAGE_MAP()
  DECLARE_DYNCREATE(CMainFrame)
};
