/*
Module : ShellItemInfo2.h
Purpose: Interface for a CShellItemInfo2 class used by the CShellTreeCtrl2 and CShellListCtrl2 classes
Created: PJN / 25-07-2020
History: PJN / 25-07-2020 1. Initial creation
         PJN / 23-04-2022 1. Updated copyright details.
                          2. Updated the code to use C++ uniform initialization for all variable
                          declarations.

Copyright (c) 2020 - 2023 by PJ Naughter (Web: www.naughter.com, Email: pjna@naughter.com)

All rights reserved.

Copyright / Usage Details:

You are allowed to include the source code in any product (commercial, shareware, freeware or otherwise) 
when your product is released in binary form. You are allowed to modify the source code in any way you want 
except you cannot modify the copyright details at the top of each module. If you want to distribute source 
code with your application, then you are only allowed to distribute versions released by the author. This is 
to maintain a single distribution point for the source code.

*/


//////////////////// Macros / Defines /////////////////////////////////////////

#pragma once

#ifndef __SHELLITEMINFO2_H__
#define __SHELLITEMINFO2_H__

#ifndef SHELLITEMINFO2_EXT_CLASS
#define SHELLITEMINFO2_EXT_CLASS
#endif //#ifndef SHELLITEMINFO2_EXT_CLASS


//////////////////// Includes /////////////////////////////////////////////////

#include "cpidl.h"


//////////////////// Classes //////////////////////////////////////////////////

//Class which gets stored in the item data in the tree or list control
class SHELLITEMINFO2_EXT_CLASS CShellItemInfo2
{
public:
//Constructors / Destructors
  CShellItemInfo2() noexcept : m_dwItemData{0},
                               m_Attribs{0}
  {
  }
  CShellItemInfo2(const CShellItemInfo2&) = delete;
  CShellItemInfo2(CShellItemInfo2&&) = delete;
  ~CShellItemInfo2() = default;

//Methods
  CShellItemInfo2& operator=(const CShellItemInfo2&) = delete;
  CShellItemInfo2& operator=(CShellItemInfo2&&) = delete;

//Member variables
  ATL::CComPtr<IShellFolder> m_pParentFolder;
  CPIDL m_pidlFQ;
  CPIDL m_pidlRel;
  DWORD_PTR m_dwItemData;
  SFGAOF m_Attribs;
};


#endif //#ifndef __SHELLITEMINFO2_H__
