#include "stdafx.h"
#include "testShellCtrls2.h"
#include "testShellCtrls2Doc.h"
#include "testShellCtrls2View.h"
#include "FilenameMaskDlg.h"
#include "RootFolderDlg.h"
#include "SelectedPathDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif //#ifdef _DEBUG


void CMyShellTreeCtrl::OnSelectionChanged(_In_ const NM_TREEVIEW* pNMTreeView)
{
  //For demonstration purposes, we will just change the document title
  TVITEM tvItem{};
  tvItem.hItem = pNMTreeView->itemNew.hItem;
  tvItem.mask = TVIF_HANDLE | TVIF_PARAM;
  if (!GetItem(&tvItem))
  {
    ASSERT(FALSE);
    return;
  }
#pragma warning(suppress: 26486 26490)
  auto pItem{reinterpret_cast<const CShellItemInfo2*>(tvItem.lParam)};
  if (pItem == nullptr)
  {
    ASSERT(FALSE);
    return;
  }
#pragma warning(suppress: 26429 26466)
  auto pParent{static_cast<CTestShellCtrlsTreeView*>(GetParent())};
  ASSERT(pParent != nullptr);
  CString sPath;
#pragma warning(suppress: 26489)
  pItem->m_pidlFQ.ToPath(sPath);
  pParent->GetDocument()->SetTitle(sPath);
}


#pragma warning(suppress: 26409 26440 26433 26477)
IMPLEMENT_DYNCREATE(CTestShellCtrlsTreeView, CView)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestShellCtrlsTreeView, CView) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_WM_SIZE()
  ON_WM_SETFOCUS()
  ON_COMMAND(ID_TOOLS_ALLOWSHELLDEFAULT, &CTestShellCtrlsTreeView::OnToolsAllowShellDefault) //NOLINT(clang-diagnostic-error)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWSHELLDEFAULT, &CTestShellCtrlsTreeView::OnUpdateToolsAllowShellDefault)
  ON_COMMAND(ID_TOOLS_SHOWFILES, &CTestShellCtrlsTreeView::OnToolsShowFiles)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWFILES, &CTestShellCtrlsTreeView::OnUpdateToolsShowFiles)
  ON_COMMAND(ID_TOOLS_HIDECDROM, &CTestShellCtrlsTreeView::OnToolsHideCDROM)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECDROM, &CTestShellCtrlsTreeView::OnUpdateToolsHideCDROM)
  ON_COMMAND(ID_TOOLS_HIDEFIXED, &CTestShellCtrlsTreeView::OnToolsHideFixed)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEFIXED, &CTestShellCtrlsTreeView::OnUpdateToolsHideFixed)
  ON_COMMAND(ID_TOOLS_HIDERAMDISKS, &CTestShellCtrlsTreeView::OnToolsHideRAMDisks)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDERAMDISKS, &CTestShellCtrlsTreeView::OnUpdateToolsHideRAMDisks)
  ON_COMMAND(ID_TOOLS_HIDEREMOVABLE, &CTestShellCtrlsTreeView::OnToolsHideRemovable)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREMOVABLE, &CTestShellCtrlsTreeView::OnUpdateToolsHideRemovable)
  ON_COMMAND(ID_TOOLS_HIDEREMOTE, &CTestShellCtrlsTreeView::OnToolsHideRemote)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREMOTE, &CTestShellCtrlsTreeView::OnUpdateToolsHideRemote)
  ON_COMMAND(ID_TOOLS_FILENAMEMASK, &CTestShellCtrlsTreeView::OnToolsFileNameMask)
  ON_COMMAND(ID_TOOLS_HIDEHIDDEN, &CTestShellCtrlsTreeView::OnToolsHideHidden)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEHIDDEN, &CTestShellCtrlsTreeView::OnUpdateToolsHideHidden)
  ON_COMMAND(ID_TOOLS_HIDEARCHIVE, &CTestShellCtrlsTreeView::OnToolsHideArchive)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEARCHIVE, &CTestShellCtrlsTreeView::OnUpdateToolsHideArchive)
  ON_COMMAND(ID_TOOLS_HIDECOMPRESSED, &CTestShellCtrlsTreeView::OnToolsHideCompressed)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECOMPRESSED, &CTestShellCtrlsTreeView::OnUpdateToolsHideCompressed)
  ON_COMMAND(ID_TOOLS_HIDESYSTEM, &CTestShellCtrlsTreeView::OnToolsHideSystem)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESYSTEM, &CTestShellCtrlsTreeView::OnUpdateToolsHideSystem)
  ON_COMMAND(ID_TOOLS_HIDETEMPORARY, &CTestShellCtrlsTreeView::OnToolsHideTemporary)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDETEMPORARY, &CTestShellCtrlsTreeView::OnUpdateToolsHideTemporary)
  ON_COMMAND(ID_TOOLS_HIDEENCRYPTED, &CTestShellCtrlsTreeView::OnToolsHideEncrypted)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEENCRYPTED, &CTestShellCtrlsTreeView::OnUpdateToolsHideEncrypted)
  ON_COMMAND(ID_TOOLS_HIDEOFFLINE, &CTestShellCtrlsTreeView::OnToolsHideOffline)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEOFFLINE, &CTestShellCtrlsTreeView::OnUpdateToolsHideOffline)
  ON_COMMAND(ID_TOOLS_HIDEREADONLY, &CTestShellCtrlsTreeView::OnToolsHideReadOnly)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREADONLY, &CTestShellCtrlsTreeView::OnUpdateToolsHideReadOnly)
  ON_COMMAND(ID_TOOLS_HIDEREPARSEPOINT, &CTestShellCtrlsTreeView::OnToolsHideReparsePoint)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREPARSEPOINT, &CTestShellCtrlsTreeView::OnUpdateToolsHideReparsePoint)
  ON_COMMAND(ID_TOOLS_HIDESPARSE, &CTestShellCtrlsTreeView::OnToolsHideSparse)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESPARSE, &CTestShellCtrlsTreeView::OnUpdateToolsHideSparse)
  ON_COMMAND(ID_TOOLS_HIDEHIDDEN2, &CTestShellCtrlsTreeView::OnToolsHideHidden2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEHIDDEN2, &CTestShellCtrlsTreeView::OnUpdateToolsHideHidden2)
  ON_COMMAND(ID_TOOLS_HIDEARCHIVE2, &CTestShellCtrlsTreeView::OnToolsHideArchive2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEARCHIVE2, &CTestShellCtrlsTreeView::OnUpdateToolsHideArchive2)
  ON_COMMAND(ID_TOOLS_HIDECOMPRESSED2, &CTestShellCtrlsTreeView::OnToolsHideCompressed2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECOMPRESSED2, &CTestShellCtrlsTreeView::OnUpdateToolsHideCompressed2)
  ON_COMMAND(ID_TOOLS_HIDESYSTEM2, &CTestShellCtrlsTreeView::OnToolsHideSystem2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESYSTEM2, &CTestShellCtrlsTreeView::OnUpdateToolsHideSystem2)
  ON_COMMAND(ID_TOOLS_HIDETEMPORARY2, &CTestShellCtrlsTreeView::OnToolsHideTemporary2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDETEMPORARY2, &CTestShellCtrlsTreeView::OnUpdateToolsHideTemporary2)
  ON_COMMAND(ID_TOOLS_HIDEENCRYPTED2, &CTestShellCtrlsTreeView::OnToolsHideEncrypted2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEENCRYPTED2, &CTestShellCtrlsTreeView::OnUpdateToolsHideEncrypted2)
  ON_COMMAND(ID_TOOLS_HIDEOFFLINE2, &CTestShellCtrlsTreeView::OnToolsHideOffline2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEOFFLINE2, &CTestShellCtrlsTreeView::OnUpdateToolsHideOffline2)
  ON_COMMAND(ID_TOOLS_HIDEREADONLY2, &CTestShellCtrlsTreeView::OnToolsHideReadOnly2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREADONLY2, &CTestShellCtrlsTreeView::OnUpdateToolsHideReadOnly2)
  ON_COMMAND(ID_TOOLS_HIDEREPARSEPOINT2, &CTestShellCtrlsTreeView::OnToolsHideReparsePoint2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREPARSEPOINT2, &CTestShellCtrlsTreeView::OnUpdateToolsHideReparsePoint2)
  ON_COMMAND(ID_TOOLS_HIDESPARSE2, &CTestShellCtrlsTreeView::OnToolsHideSparse2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESPARSE2, &CTestShellCtrlsTreeView::OnUpdateToolsHideSparse2)
  ON_COMMAND(ID_TOOLS_SETROOTFOLDER, &CTestShellCtrlsTreeView::OnToolsSetRootFolder)
  ON_WM_DESTROY()
  ON_COMMAND(ID_TOOLS_SHOWSHAREDFOLDERS, &CTestShellCtrlsTreeView::OnToolsShowSharedFolders)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWSHAREDFOLDERS, &CTestShellCtrlsTreeView::OnUpdateToolsShowSharedFolders)
  ON_COMMAND(ID_TOOLS_SHOWROOTEDFOLDER, &CTestShellCtrlsTreeView::OnToolsShowRootedFolder)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWROOTEDFOLDER, &CTestShellCtrlsTreeView::OnUpdateToolsShowRootedFolder)
  ON_COMMAND(ID_TOOLS_SETSELECTEDPATH, &CTestShellCtrlsTreeView::OnToolsSetSelectedPath)
  ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
  ON_COMMAND(ID_TOOLS_BACK, &CTestShellCtrlsTreeView::OnBack)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_BACK, &CTestShellCtrlsTreeView::OnUpdateBack)
  ON_COMMAND(ID_TOOLS_FORWARD, &CTestShellCtrlsTreeView::OnForward)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_FORWARD, &CTestShellCtrlsTreeView::OnUpdateForward)
  ON_COMMAND(ID_TOOLS_UPONELEVEL, &CTestShellCtrlsTreeView::OnUpOneLevel)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_UPONELEVEL, &CTestShellCtrlsTreeView::OnUpdateUpOneLevel)
  ON_COMMAND(ID_SHELLCTRLS2_SHELLDEFAULT, &CTestShellCtrlsTreeView::OnShellDefault)
  ON_UPDATE_COMMAND_UI(ID_SHELLCTRLS2_SHELLDEFAULT, &CTestShellCtrlsTreeView::OnUpdateShellDefault)
  ON_COMMAND(ID_SHELLCTRLS2_REFRESH, &CTestShellCtrlsTreeView::OnRefresh)
  ON_COMMAND(ID_SHELLCTRLS2_SHELLPROPERTIES, &CTestShellCtrlsTreeView::OnShellProperties)
  ON_COMMAND(ID_TOOLS_AUTOREFRESH, &CTestShellCtrlsTreeView::OnAutoRefresh)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_AUTOREFRESH, &CTestShellCtrlsTreeView::OnUpdateAutoRefresh)
END_MESSAGE_MAP()

CTestShellCtrlsTreeView::CTestShellCtrlsTreeView() noexcept //NOLINT(modernize-use-equals-default)
{
}

BOOL CTestShellCtrlsTreeView::PreCreateWindow(CREATESTRUCT& cs)
{
  return __super::PreCreateWindow(cs);
}

void CTestShellCtrlsTreeView::OnDraw(CDC* /*pDC*/) noexcept
{
}

BOOL CTestShellCtrlsTreeView::OnPreparePrinting(CPrintInfo* pInfo)
{
  return DoPreparePrinting(pInfo);
}

void CTestShellCtrlsTreeView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
}

void CTestShellCtrlsTreeView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
}

#pragma warning(suppress: 26434 26440)
CTestShellCtrls2Doc* CTestShellCtrlsTreeView::GetDocument()
{
  ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestShellCtrls2Doc)));
#pragma warning(suppress: 26466)
  return static_cast<CTestShellCtrls2Doc*>(m_pDocument);
}

#pragma warning(suppress: 26434)
int CTestShellCtrlsTreeView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  //Create the tree view
  const CRect r;
  if (!m_TreeCtrl.Create(WS_VISIBLE | WS_CHILD | WS_TABSTOP | TVS_HASBUTTONS | TVS_NOHSCROLL | TVS_SHOWSELALWAYS, r, this, 100))
    return -1;

  //Turn on the vista explorer theme if necessary
  SetWindowTheme(m_TreeCtrl.GetSafeHwnd(), L"explorer", nullptr);

  //Turn on the various Vista style extended styles
  m_TreeCtrl.SendMessage(TVM_SETEXTENDEDSTYLE, 0, TVS_EX_AUTOHSCROLL | TVS_EX_DOUBLEBUFFER | TVS_EX_FADEINOUTEXPANDOS);

  return 0;
}

#pragma warning(suppress: 26434)
void CTestShellCtrlsTreeView::OnSize(UINT nType, int cx, int cy)
{
  //Let the parent class do its thing
  __super::OnSize(nType, cx, cy);

  //Let the tree control occupy all the space of the client area
  CRect rClient;
  GetClientRect(&rClient);
  m_TreeCtrl.MoveWindow(rClient);
}

#pragma warning(suppress: 26434)
void CTestShellCtrlsTreeView::OnSetFocus(CWnd* pOldWnd)
{
  //Let the parent class do its thing
  __super::OnSetFocus(pOldWnd);

  //Ensure the tree view control gets the focus when the view gets the focus 
  m_TreeCtrl.SetFocus();
}

void CTestShellCtrlsTreeView::OnToolsShowFiles()
{
  m_TreeCtrl.SetShowFiles(!m_TreeCtrl.GetShowFiles());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsShowFiles(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetShowFiles());
}

void CTestShellCtrlsTreeView::OnInitialUpdate()
{
  //Let the parent class do its thing
  __super::OnInitialUpdate();

  //Set the initially selected item in the tree control if possible
  CWinApp* pApp{AfxGetApp()};
#pragma warning(suppress: 26496)
  AFXASSUME(pApp != nullptr);
  LPBYTE pData{nullptr};
  UINT nBytes{0};
  pApp->GetProfileBinary(_T("Settings"), _T("Last Path"), &pData, &nBytes);
#pragma warning(suppress: 26490)
  if (pData != nullptr)
  {
    CPIDL pidl;
    pidl.FromMemory(pData, nBytes);
    m_TreeCtrl.SelectPath(pidl);
  }
#pragma warning(suppress: 26401 26409)
  delete [] pData;
}

BOOL CTestShellCtrlsTreeView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
  //Give the control first crack
  if (m_TreeCtrl.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
    return TRUE;
  return __super::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CTestShellCtrlsTreeView::OnToolsHideCDROM()
{
  if (m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM)
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM);
  else
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideCDROM(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM);
}

void CTestShellCtrlsTreeView::OnToolsHideFixed()
{
  if (m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED)
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED);
  else
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideFixed(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED);
}

void CTestShellCtrlsTreeView::OnToolsHideRAMDisks()
{
  if (m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK)
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
  else
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideRAMDisks(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
}

void CTestShellCtrlsTreeView::OnToolsHideRemovable()
{
  if (m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE)
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
  else
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideRemovable(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
}

void CTestShellCtrlsTreeView::OnToolsHideRemote()
{
  if (m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE)
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE);
  else
    m_TreeCtrl.SetDriveHideFlags(m_TreeCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideRemote(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE);
}

void CTestShellCtrlsTreeView::OnToolsFileNameMask()
{
  CFilenameMaskDlg dlg;
  dlg.m_sMask = m_TreeCtrl.GetFilenameMasks();
  if (dlg.DoModal() == IDOK)
    m_TreeCtrl.AddMultipleFilenameMasks(dlg.m_sMask);
}

void CTestShellCtrlsTreeView::OnToolsHideHidden()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_HIDDEN)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_HIDDEN);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_HIDDEN);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideHidden(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_HIDDEN);
}

void CTestShellCtrlsTreeView::OnToolsHideArchive()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ARCHIVE)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_ARCHIVE);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_ARCHIVE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideArchive(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ARCHIVE);
}

void CTestShellCtrlsTreeView::OnToolsHideCompressed()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_COMPRESSED)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_COMPRESSED);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_COMPRESSED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideCompressed(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_COMPRESSED);
}

void CTestShellCtrlsTreeView::OnToolsHideSystem()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SYSTEM)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_SYSTEM);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_SYSTEM);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideSystem(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SYSTEM);
}

void CTestShellCtrlsTreeView::OnToolsHideTemporary()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_TEMPORARY)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_TEMPORARY);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_TEMPORARY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideTemporary(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_TEMPORARY);
}

void CTestShellCtrlsTreeView::OnToolsHideEncrypted()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ENCRYPTED)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_ENCRYPTED);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_ENCRYPTED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideEncrypted(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ENCRYPTED);
}

void CTestShellCtrlsTreeView::OnToolsHideOffline()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_OFFLINE)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_OFFLINE);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideOffline(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_OFFLINE);
}

void CTestShellCtrlsTreeView::OnToolsHideReadOnly()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_READONLY)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_READONLY);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_READONLY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideReadOnly(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_READONLY);
}

void CTestShellCtrlsTreeView::OnToolsHideReparsePoint()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_REPARSE_POINT);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_REPARSE_POINT);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideReparsePoint(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT);
}

void CTestShellCtrlsTreeView::OnToolsHideSparse()
{
  if (m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE)
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_SPARSE_FILE);
  else
    m_TreeCtrl.SetFileHideFlags(m_TreeCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_SPARSE_FILE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideSparse(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE);
}

void CTestShellCtrlsTreeView::OnToolsHideHidden2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_HIDDEN)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_HIDDEN);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_HIDDEN);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideHidden2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_HIDDEN);
}

void CTestShellCtrlsTreeView::OnToolsHideArchive2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ARCHIVE)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_ARCHIVE);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_ARCHIVE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideArchive2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ARCHIVE);
}

void CTestShellCtrlsTreeView::OnToolsHideCompressed2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_COMPRESSED)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_COMPRESSED);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_COMPRESSED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideCompressed2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_COMPRESSED);
}

void CTestShellCtrlsTreeView::OnToolsHideSystem2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SYSTEM)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_SYSTEM);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_SYSTEM);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideSystem2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SYSTEM);
}

void CTestShellCtrlsTreeView::OnToolsHideTemporary2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_TEMPORARY)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_TEMPORARY);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_TEMPORARY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideTemporary2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_TEMPORARY);
}

void CTestShellCtrlsTreeView::OnToolsHideEncrypted2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ENCRYPTED)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_ENCRYPTED);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_ENCRYPTED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideEncrypted2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ENCRYPTED);
}

void CTestShellCtrlsTreeView::OnToolsHideOffline2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_OFFLINE)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_OFFLINE);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideOffline2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnToolsHideReadOnly2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_READONLY)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_READONLY);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_READONLY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideReadOnly2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_READONLY);
}


void CTestShellCtrlsTreeView::OnToolsHideReparsePoint2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_REPARSE_POINT);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_REPARSE_POINT);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideReparsePoint2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT);
}

void CTestShellCtrlsTreeView::OnToolsHideSparse2()
{
  if (m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE)
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_SPARSE_FILE);
  else
    m_TreeCtrl.SetFolderHideFlags(m_TreeCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_SPARSE_FILE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsHideSparse2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE);
}

void CTestShellCtrlsTreeView::OnToolsShowSharedFolders()
{
  m_TreeCtrl.SetUsingDifferentIconForSharedFolders(!m_TreeCtrl.GetUsingDifferentIconForSharedFolders());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsShowSharedFolders(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetUsingDifferentIconForSharedFolders());
}

void CTestShellCtrlsTreeView::OnToolsSetRootFolder()
{
  CRootFolderDlg dlg;
  m_TreeCtrl.GetRootFolder().ToPath(dlg.m_sFolder);
  if (dlg.DoModal() == IDOK)
    m_TreeCtrl.SetRootFolder(dlg.m_sFolder);
}

#pragma warning(suppress: 26434)
void CTestShellCtrlsTreeView::OnDestroy()
{
  //Remember the selected item in the tree control, ready for the next time around
  HTREEITEM hSelItem{m_TreeCtrl.GetSelectedItem()};
  CPIDL pidlSelected;
  m_TreeCtrl.GetItemPIDL(hSelItem, pidlSelected);
  CWinApp* pApp{AfxGetApp()};
#pragma warning(suppress: 26496)
  AFXASSUME(pApp != nullptr);
  auto data{pidlSelected.ToByteArray()};
#pragma warning(suppress: 26472)
  pApp->WriteProfileBinary(_T("Settings"), _T("Last Path"), data.data(), static_cast<UINT>(data.size()));

  //Let the parent class do its thing
  __super::OnDestroy();
}

void CTestShellCtrlsTreeView::OnToolsShowRootedFolder()
{
  m_TreeCtrl.SetShowRootedFolder(!m_TreeCtrl.GetShowRootedFolder());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsShowRootedFolder(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetShowRootedFolder());
}

void CTestShellCtrlsTreeView::OnToolsSetSelectedPath()
{
  CSelectedPathDlg dlg;
  m_TreeCtrl.GetItemPath(m_TreeCtrl.GetSelectedItem(), dlg.m_sPath);
  if (dlg.DoModal() == IDOK)
    m_TreeCtrl.SelectPath(dlg.m_sPath, dlg.m_bExpand);
}

void CTestShellCtrlsTreeView::OnBack()
{
  m_TreeCtrl.GoBack();
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateBack(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(m_TreeCtrl.CanGoBack());
}

void CTestShellCtrlsTreeView::OnForward()
{
  m_TreeCtrl.GoForward();
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateForward(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(m_TreeCtrl.CanGoForward());
}

void CTestShellCtrlsTreeView::OnUpOneLevel()
{
  m_TreeCtrl.UpOneLevel();
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateUpOneLevel(CCmdUI* pCmdUI)
{
  HTREEITEM hItem{m_TreeCtrl.GetSelectedItem()};
  if (hItem)
#pragma warning(suppress: 26486)
    pCmdUI->Enable(m_TreeCtrl.GetParentItem(hItem) != nullptr);
  else
#pragma warning(suppress: 26486)
    pCmdUI->Enable(FALSE);
}

void CTestShellCtrlsTreeView::OnShellDefault()
{
  m_TreeCtrl.DoShellDefault(m_TreeCtrl.GetSelectedItem());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateShellDefault(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(m_TreeCtrl.GetAllowDoShellDefault() && (m_TreeCtrl.GetSelectedItem() != nullptr));
}

void CTestShellCtrlsTreeView::OnRefresh()
{
  m_TreeCtrl.Refresh();
}

void CTestShellCtrlsTreeView::OnShellProperties()
{
  m_TreeCtrl.DoShellProperties(m_TreeCtrl.GetSelectedItem());
}

#pragma warning(suppress: 26440)
void CTestShellCtrlsTreeView::OnToolsAllowShellDefault()
{
  m_TreeCtrl.SetAllowDoShellDefault(!m_TreeCtrl.GetAllowDoShellDefault());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateToolsAllowShellDefault(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetAllowDoShellDefault());
}

void CTestShellCtrlsTreeView::OnAutoRefresh()
{
  m_TreeCtrl.SetAutoRefresh(!m_TreeCtrl.GetAutoRefresh());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsTreeView::OnUpdateAutoRefresh(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_TreeCtrl.GetAutoRefresh());
}


#pragma warning(suppress: 26409 26440 26433 26477)
IMPLEMENT_DYNCREATE(CTestShellCtrlsListView, CView)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestShellCtrlsListView, CView) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_WM_SIZE()
  ON_WM_SETFOCUS()
  ON_COMMAND(ID_TOOLS_SHOWFILES, &CTestShellCtrlsListView::OnToolsShowFiles)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWFILES, &CTestShellCtrlsListView::OnUpdateToolsShowFiles)
  ON_COMMAND(ID_TOOLS_HIDECDROM, &CTestShellCtrlsListView::OnToolsHideCDROM)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECDROM, &CTestShellCtrlsListView::OnUpdateToolsHideCDROM)
  ON_COMMAND(ID_TOOLS_HIDEFIXED, &CTestShellCtrlsListView::OnToolsHideFixed)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEFIXED, &CTestShellCtrlsListView::OnUpdateToolsHideFixed)
  ON_COMMAND(ID_TOOLS_HIDERAMDISKS, &CTestShellCtrlsListView::OnToolsHideRAMDisks)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDERAMDISKS, &CTestShellCtrlsListView::OnUpdateToolsHideRAMDisks)
  ON_COMMAND(ID_TOOLS_HIDEREMOVABLE, &CTestShellCtrlsListView::OnToolsHideRemovable)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREMOVABLE, &CTestShellCtrlsListView::OnUpdateToolsHideRemovable)
  ON_COMMAND(ID_TOOLS_HIDEREMOTE, &CTestShellCtrlsListView::OnToolsHideRemote)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREMOTE, &CTestShellCtrlsListView::OnUpdateToolsHideRemote)
  ON_COMMAND(ID_TOOLS_FILENAMEMASK, &CTestShellCtrlsListView::OnToolsFileNameMask)
  ON_COMMAND(ID_TOOLS_HIDEHIDDEN, &CTestShellCtrlsListView::OnToolsHideHidden)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEHIDDEN, &CTestShellCtrlsListView::OnUpdateToolsHideHidden)
  ON_COMMAND(ID_TOOLS_HIDEARCHIVE, &CTestShellCtrlsListView::OnToolsHideArchive)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEARCHIVE, &CTestShellCtrlsListView::OnUpdateToolsHideArchive)
  ON_COMMAND(ID_TOOLS_HIDECOMPRESSED, &CTestShellCtrlsListView::OnToolsHideCompressed)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECOMPRESSED, &CTestShellCtrlsListView::OnUpdateToolsHideCompressed)
  ON_COMMAND(ID_TOOLS_HIDESYSTEM, &CTestShellCtrlsListView::OnToolsHideSystem)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESYSTEM, &CTestShellCtrlsListView::OnUpdateToolsHideSystem)
  ON_COMMAND(ID_TOOLS_HIDETEMPORARY, &CTestShellCtrlsListView::OnToolsHideTemporary)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDETEMPORARY, &CTestShellCtrlsListView::OnUpdateToolsHideTemporary)
  ON_COMMAND(ID_TOOLS_HIDEENCRYPTED, &CTestShellCtrlsListView::OnToolsHideEncrypted)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEENCRYPTED, &CTestShellCtrlsListView::OnUpdateToolsHideEncrypted)
  ON_COMMAND(ID_TOOLS_HIDEOFFLINE, &CTestShellCtrlsListView::OnToolsHideOffline)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEOFFLINE, &CTestShellCtrlsListView::OnUpdateToolsHideOffline)
  ON_COMMAND(ID_TOOLS_HIDEREADONLY, &CTestShellCtrlsListView::OnToolsHideReadOnly)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREADONLY, &CTestShellCtrlsListView::OnUpdateToolsHideReadOnly)
  ON_COMMAND(ID_TOOLS_HIDEREPARSEPOINT, &CTestShellCtrlsListView::OnToolsHideReparsePoint)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREPARSEPOINT, &CTestShellCtrlsListView::OnUpdateToolsHideReparsePoint)
  ON_COMMAND(ID_TOOLS_HIDESPARSE, &CTestShellCtrlsListView::OnToolsHideSparse)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESPARSE, &CTestShellCtrlsListView::OnUpdateToolsHideSparse)
  ON_COMMAND(ID_TOOLS_HIDEHIDDEN2, &CTestShellCtrlsListView::OnToolsHideHidden2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEHIDDEN2, &CTestShellCtrlsListView::OnUpdateToolsHideHidden2)
  ON_COMMAND(ID_TOOLS_HIDEARCHIVE2, &CTestShellCtrlsListView::OnToolsHideArchive2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEARCHIVE2, &CTestShellCtrlsListView::OnUpdateToolsHideArchive2)
  ON_COMMAND(ID_TOOLS_HIDECOMPRESSED2, &CTestShellCtrlsListView::OnToolsHideCompressed2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDECOMPRESSED2, &CTestShellCtrlsListView::OnUpdateToolsHideCompressed2)
  ON_COMMAND(ID_TOOLS_HIDESYSTEM2, &CTestShellCtrlsListView::OnToolsHideSystem2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESYSTEM2, &CTestShellCtrlsListView::OnUpdateToolsHideSystem2)
  ON_COMMAND(ID_TOOLS_HIDETEMPORARY2, &CTestShellCtrlsListView::OnToolsHideTemporary2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDETEMPORARY2, &CTestShellCtrlsListView::OnUpdateToolsHideTemporary2)
  ON_COMMAND(ID_TOOLS_HIDEENCRYPTED2, &CTestShellCtrlsListView::OnToolsHideEncrypted2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEENCRYPTED2, &CTestShellCtrlsListView::OnUpdateToolsHideEncrypted2)
  ON_COMMAND(ID_TOOLS_HIDEOFFLINE2, &CTestShellCtrlsListView::OnToolsHideOffline2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEOFFLINE2, &CTestShellCtrlsListView::OnUpdateToolsHideOffline2)
  ON_COMMAND(ID_TOOLS_HIDEREADONLY2, &CTestShellCtrlsListView::OnToolsHideReadOnly2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREADONLY2, &CTestShellCtrlsListView::OnUpdateToolsHideReadOnly2)
  ON_COMMAND(ID_TOOLS_HIDEREPARSEPOINT2, &CTestShellCtrlsListView::OnToolsHideReparsePoint2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDEREPARSEPOINT2, &CTestShellCtrlsListView::OnUpdateToolsHideReparsePoint2)
  ON_COMMAND(ID_TOOLS_HIDESPARSE2, &CTestShellCtrlsListView::OnToolsHideSparse2)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_HIDESPARSE2, &CTestShellCtrlsListView::OnUpdateToolsHideSparse2)
  ON_WM_DESTROY()
  ON_COMMAND(ID_TOOLS_SHOWSHAREDFOLDERS, &CTestShellCtrlsListView::OnToolsShowSharedFolders)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_SHOWSHAREDFOLDERS, &CTestShellCtrlsListView::OnUpdateToolsShowSharedFolders)
  ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
  ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
  ON_COMMAND(ID_SHELLCTRLS2_REFRESH, &CTestShellCtrlsListView::OnRefresh)
  ON_COMMAND(ID_SHELLCTRLS2_SHELLDEFAULT, &CTestShellCtrlsListView::OnShellDefault)
  ON_UPDATE_COMMAND_UI(ID_SHELLCTRLS2_SHELLDEFAULT, &CTestShellCtrlsListView::OnUpdateShellDefault)
  ON_COMMAND(ID_SHELLCTRLS2_SHELLPROPERTIES, &CTestShellCtrlsListView::OnShellProperties)
  ON_UPDATE_COMMAND_UI(ID_SHELLCTRLS2_SHELLPROPERTIES, &CTestShellCtrlsListView::OnUpdateShellProperties)
  ON_COMMAND(ID_SHELLCTRLS2_VIEW_REFRESH, &CTestShellCtrlsListView::OnRefresh)
  ON_COMMAND(ID_TOOLS_ALLOWSHELLDEFAULT, &CTestShellCtrlsListView::OnToolsAllowShellDefault)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_ALLOWSHELLDEFAULT, &CTestShellCtrlsListView::OnUpdateToolsAllowShellDefault)
  ON_COMMAND(ID_TOOLS_AUTOREFRESH, &CTestShellCtrlsListView::OnAutoRefresh)
  ON_UPDATE_COMMAND_UI(ID_TOOLS_AUTOREFRESH, &CTestShellCtrlsListView::OnUpdateAutoRefresh)
END_MESSAGE_MAP()

CTestShellCtrlsListView::CTestShellCtrlsListView() noexcept //NOLINT(modernize-use-equals-default)
{
}

BOOL CTestShellCtrlsListView::PreCreateWindow(CREATESTRUCT& cs)
{
  return __super::PreCreateWindow(cs);
}

void CTestShellCtrlsListView::OnDraw(CDC* /*pDC*/) noexcept
{
}

BOOL CTestShellCtrlsListView::OnPreparePrinting(CPrintInfo* pInfo)
{
  return DoPreparePrinting(pInfo);
}

void CTestShellCtrlsListView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
}

void CTestShellCtrlsListView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/) noexcept
{
}

#pragma warning(suppress: 26434 26440)
CTestShellCtrls2Doc* CTestShellCtrlsListView::GetDocument()
{
  ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestShellCtrls2Doc)));
#pragma warning(suppress: 26466)
  return static_cast<CTestShellCtrls2Doc*>(m_pDocument);
}

#pragma warning(suppress: 26434)
int CTestShellCtrlsListView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  //Create the tree view
  const CRect r;
  if (!m_ListCtrl.Create(WS_VISIBLE | WS_CHILD | WS_TABSTOP | LVS_ICON | LVS_EDITLABELS | LVS_SHOWSELALWAYS, r, this, 100))
    return -1;

  //Turn on the vista explorer theme if necessary
  SetWindowTheme(m_ListCtrl.GetSafeHwnd(), L"explorer", nullptr);

  //Turn on the various Vista style extended styles
  m_ListCtrl.SetExtendedStyle(LVS_EX_DOUBLEBUFFER | LVS_EX_FULLROWSELECT);

  return 0;
}

#pragma warning(suppress: 26434)
void CTestShellCtrlsListView::OnSize(UINT nType, int cx, int cy)
{
  //Let the parent class do its thing
  __super::OnSize(nType, cx, cy);

  //Let the tree control occupy all the space of the client area
  CRect rClient;
  GetClientRect(&rClient);
  m_ListCtrl.MoveWindow(rClient);
}

#pragma warning(suppress: 26434)
void CTestShellCtrlsListView::OnSetFocus(CWnd* pOldWnd)
{
  //Let the parent class do its thing
  __super::OnSetFocus(pOldWnd);
  
  //Ensure the tree view control gets the focus when the view gets the focus 
  m_ListCtrl.SetFocus();
}

void CTestShellCtrlsListView::OnToolsShowFiles()
{
  m_ListCtrl.SetShowFiles(!m_ListCtrl.GetShowFiles());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsShowFiles(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetShowFiles());
}

void CTestShellCtrlsListView::OnInitialUpdate()
{
  //Let the parent class do its thing
  __super::OnInitialUpdate();

  //Set the initially selected item in the tree control if possible
  CWinApp* pApp{AfxGetApp()};
#pragma warning(suppress: 26496)
  AFXASSUME(pApp != nullptr);
  LPBYTE pData{nullptr};
  UINT nBytes{0};
  pApp->GetProfileBinary(_T("Settings"), _T("Last Path"), &pData, &nBytes);
#pragma warning(suppress: 26490)
  if (pData != nullptr)
  {
    CPIDL pidl;
    pidl.FromMemory(pData, nBytes);
    m_ListCtrl.DisplayFolder(pidl);
  }
#pragma warning(suppress: 26401 26409)
  delete [] pData;
}

BOOL CTestShellCtrlsListView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
  //Give the control first crack
  if (m_ListCtrl.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
    return TRUE;
  return __super::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CTestShellCtrlsListView::OnToolsHideCDROM()
{
  if (m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM)
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM);
  else
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideCDROM(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_CDROM);
}

void CTestShellCtrlsListView::OnToolsHideFixed()
{
  if (m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED)
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED);
  else
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideFixed(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_FIXED);
}

void CTestShellCtrlsListView::OnToolsHideRAMDisks()
{
  if (m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK)
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
  else
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideRAMDisks(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_RAMDISK);
}

void CTestShellCtrlsListView::OnToolsHideRemovable()
{
  if (m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE)
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
  else
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideRemovable(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOVABLE);
}

void CTestShellCtrlsListView::OnToolsHideRemote()
{
  if (m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE)
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() & ~CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE);
  else
    m_ListCtrl.SetDriveHideFlags(m_ListCtrl.GetDriveHideFlags() | CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideRemote(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetDriveHideFlags() & CShellTreeCtrl2::DriveType::DRIVE_ATTRIBUTE_REMOTE);
}

void CTestShellCtrlsListView::OnToolsFileNameMask()
{
  CFilenameMaskDlg dlg;
  dlg.m_sMask = m_ListCtrl.GetFilenameMasks();
  if (dlg.DoModal() == IDOK)
    m_ListCtrl.AddMultipleFilenameMasks(dlg.m_sMask);
}

void CTestShellCtrlsListView::OnToolsHideHidden()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_HIDDEN)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_HIDDEN);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_HIDDEN);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideHidden(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_HIDDEN);
}

void CTestShellCtrlsListView::OnToolsHideArchive()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ARCHIVE)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_ARCHIVE);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_ARCHIVE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideArchive(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ARCHIVE);
}

void CTestShellCtrlsListView::OnToolsHideCompressed()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_COMPRESSED)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_COMPRESSED);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_COMPRESSED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideCompressed(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_COMPRESSED);
}

void CTestShellCtrlsListView::OnToolsHideSystem()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SYSTEM)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_SYSTEM);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_SYSTEM);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideSystem(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SYSTEM);
}

void CTestShellCtrlsListView::OnToolsHideTemporary()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_TEMPORARY)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_TEMPORARY);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_TEMPORARY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideTemporary(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_TEMPORARY);
}

void CTestShellCtrlsListView::OnToolsHideEncrypted()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ENCRYPTED)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_ENCRYPTED);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_ENCRYPTED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideEncrypted(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_ENCRYPTED);
}

void CTestShellCtrlsListView::OnToolsHideOffline()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_OFFLINE)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_OFFLINE);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideOffline(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_OFFLINE);
}

void CTestShellCtrlsListView::OnToolsHideReadOnly()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_READONLY)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_READONLY);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_READONLY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideReadOnly(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_READONLY);
}

void CTestShellCtrlsListView::OnToolsHideReparsePoint()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_REPARSE_POINT);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_REPARSE_POINT);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideReparsePoint(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT);
}

void CTestShellCtrlsListView::OnToolsHideSparse()
{
  if (m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE)
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() & ~FILE_ATTRIBUTE_SPARSE_FILE);
  else
    m_ListCtrl.SetFileHideFlags(m_ListCtrl.GetFileHideFlags() | FILE_ATTRIBUTE_SPARSE_FILE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideSparse(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFileHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE);
}

void CTestShellCtrlsListView::OnToolsHideHidden2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_HIDDEN)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_HIDDEN);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_HIDDEN);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideHidden2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_HIDDEN);
}

void CTestShellCtrlsListView::OnToolsHideArchive2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ARCHIVE)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_ARCHIVE);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_ARCHIVE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideArchive2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ARCHIVE);
}

void CTestShellCtrlsListView::OnToolsHideCompressed2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_COMPRESSED)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_COMPRESSED);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_COMPRESSED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideCompressed2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_COMPRESSED);
}

void CTestShellCtrlsListView::OnToolsHideSystem2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SYSTEM)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_SYSTEM);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_SYSTEM);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideSystem2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SYSTEM);
}

void CTestShellCtrlsListView::OnToolsHideTemporary2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_TEMPORARY)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_TEMPORARY);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_TEMPORARY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideTemporary2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_TEMPORARY);
}

void CTestShellCtrlsListView::OnToolsHideEncrypted2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ENCRYPTED)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_ENCRYPTED);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_ENCRYPTED);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideEncrypted2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_ENCRYPTED);
}

void CTestShellCtrlsListView::OnToolsHideOffline2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_OFFLINE)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_OFFLINE);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideOffline2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_OFFLINE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnToolsHideReadOnly2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_READONLY)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_READONLY);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_READONLY);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideReadOnly2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_READONLY);
}

void CTestShellCtrlsListView::OnToolsHideReparsePoint2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_REPARSE_POINT);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_REPARSE_POINT);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideReparsePoint2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_REPARSE_POINT);
}

void CTestShellCtrlsListView::OnToolsHideSparse2()
{
  if (m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE)
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() & ~FILE_ATTRIBUTE_SPARSE_FILE);
  else
    m_ListCtrl.SetFolderHideFlags(m_ListCtrl.GetFolderHideFlags() | FILE_ATTRIBUTE_SPARSE_FILE);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsHideSparse2(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetFolderHideFlags() & FILE_ATTRIBUTE_SPARSE_FILE);
}

void CTestShellCtrlsListView::OnToolsShowSharedFolders()
{
  m_ListCtrl.SetUsingDifferentIconForSharedFolders(!m_ListCtrl.GetUsingDifferentIconForSharedFolders());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsShowSharedFolders(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetUsingDifferentIconForSharedFolders());
}

void CTestShellCtrlsListView::OnRefresh()
{
  m_ListCtrl.Refresh();
}

void CTestShellCtrlsListView::OnShellProperties()
{
  const int nSelItem{m_ListCtrl.GetNextItem(-1, LVNI_SELECTED)};
  m_ListCtrl.DoShellProperties(nSelItem);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateShellProperties(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(m_ListCtrl.GetSelectedCount() == 1);
}

#pragma warning(suppress: 26440)
void CTestShellCtrlsListView::OnToolsAllowShellDefault()
{
  m_ListCtrl.SetAllowDoShellDefault(!m_ListCtrl.GetAllowDoShellDefault());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateToolsAllowShellDefault(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetAllowDoShellDefault());
}

void CTestShellCtrlsListView::OnAutoRefresh()
{
  m_ListCtrl.SetAutoRefresh(!m_ListCtrl.GetAutoRefresh());
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateAutoRefresh(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(m_ListCtrl.GetAutoRefresh());
}

void CTestShellCtrlsListView::OnShellDefault()
{
  const int nSelItem{m_ListCtrl.GetNextItem(-1, LVNI_SELECTED)};
  m_ListCtrl.DoShellDefault(nSelItem);
}

#pragma warning(suppress: 26429)
void CTestShellCtrlsListView::OnUpdateShellDefault(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(m_ListCtrl.GetSelectedCount() == 1);
}
