#pragma once

#include "ShellTreeCtrl2.h"
#include "ShellListCtrl2.h"


class CMyShellTreeCtrl : public CShellTreeCtrl2
{
protected:
  //Just override one method for demonstration purposes
  void OnSelectionChanged(_In_ const NM_TREEVIEW* pNMTreeView) override;
};

class CTestShellCtrlsTreeView : public CView
{
public:
//Constructors / Destructors
  CTestShellCtrlsTreeView(const CTestShellCtrlsTreeView&) = delete;
  CTestShellCtrlsTreeView(CTestShellCtrlsTreeView&&) = delete;
  ~CTestShellCtrlsTreeView() = default; //NOLINT(modernize-use-override)

//Methods
  CTestShellCtrlsTreeView& operator=(const CTestShellCtrlsTreeView&) = delete;
  CTestShellCtrlsTreeView& operator=(CTestShellCtrlsTreeView&&) = delete;
  CTestShellCtrls2Doc* GetDocument();
  void OnDraw(CDC* pDC) noexcept override;
  BOOL PreCreateWindow(CREATESTRUCT& cs) override;
  BOOL OnPreparePrinting(CPrintInfo* pInfo) override;
  void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) noexcept override;
  void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo) noexcept override;
  void OnInitialUpdate() override;
  BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) override;

//Member variables
  CMyShellTreeCtrl m_TreeCtrl;

protected:
//Constructors / Destructors
  CTestShellCtrlsTreeView() noexcept;

//Message handlers
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnSetFocus(CWnd* pOldWnd);
  afx_msg void OnToolsShowFiles();
  afx_msg void OnUpdateToolsShowFiles(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCDROM();
  afx_msg void OnUpdateToolsHideCDROM(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideFixed();
  afx_msg void OnUpdateToolsHideFixed(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRAMDisks();
  afx_msg void OnUpdateToolsHideRAMDisks(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRemovable();
  afx_msg void OnUpdateToolsHideRemovable(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRemote();
  afx_msg void OnUpdateToolsHideRemote(CCmdUI* pCmdUI);
  afx_msg void OnToolsFileNameMask();
  afx_msg void OnToolsHideHidden();
  afx_msg void OnUpdateToolsHideHidden(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideArchive();
  afx_msg void OnUpdateToolsHideArchive(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCompressed();
  afx_msg void OnUpdateToolsHideCompressed(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSystem();
  afx_msg void OnUpdateToolsHideSystem(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideTemporary();
  afx_msg void OnUpdateToolsHideTemporary(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideEncrypted();
  afx_msg void OnUpdateToolsHideEncrypted(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideOffline();
  afx_msg void OnUpdateToolsHideOffline(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReadOnly();
  afx_msg void OnUpdateToolsHideReadOnly(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReparsePoint();
  afx_msg void OnUpdateToolsHideReparsePoint(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSparse();
  afx_msg void OnUpdateToolsHideSparse(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideHidden2();
  afx_msg void OnUpdateToolsHideHidden2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideArchive2();
  afx_msg void OnUpdateToolsHideArchive2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCompressed2();
  afx_msg void OnUpdateToolsHideCompressed2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSystem2();
  afx_msg void OnUpdateToolsHideSystem2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideTemporary2();
  afx_msg void OnUpdateToolsHideTemporary2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideEncrypted2();
  afx_msg void OnUpdateToolsHideEncrypted2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideOffline2();
  afx_msg void OnUpdateToolsHideOffline2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReadOnly2();
  afx_msg void OnUpdateToolsHideReadOnly2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReparsePoint2();
  afx_msg void OnUpdateToolsHideReparsePoint2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSparse2();
  afx_msg void OnUpdateToolsHideSparse2(CCmdUI* pCmdUI);
  afx_msg void OnToolsSetRootFolder();
  afx_msg void OnDestroy();
  afx_msg void OnToolsShowSharedFolders();
  afx_msg void OnUpdateToolsShowSharedFolders(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowRootedFolder();
  afx_msg void OnUpdateToolsShowRootedFolder(CCmdUI* pCmdUI);
  afx_msg void OnToolsSetSelectedPath();
  afx_msg void OnBack();
  afx_msg void OnUpdateBack(CCmdUI* pCmdUI);
  afx_msg void OnForward();
  afx_msg void OnUpdateForward(CCmdUI* pCmdUI);
  afx_msg void OnUpOneLevel();
  afx_msg void OnUpdateUpOneLevel(CCmdUI* pCmdUI);
  afx_msg void OnShellDefault();
  afx_msg void OnRefresh();
  afx_msg void OnUpdateShellDefault(CCmdUI* pCmdUI);
  afx_msg void OnToolsAllowShellDefault();
  afx_msg void OnUpdateToolsAllowShellDefault(CCmdUI* pCmdUI);
  afx_msg void OnShellProperties();
  afx_msg void OnAutoRefresh();
  afx_msg void OnUpdateAutoRefresh(CCmdUI* pCmdUI);

  DECLARE_MESSAGE_MAP()
  DECLARE_DYNCREATE(CTestShellCtrlsTreeView)
};


class CMyShellListCtrl : public CShellListCtrl2
{
protected:
  //Just override one method for demonstration purposes
  //void OnSelectionChanged(_In_ NM_LISTVIEW* pNMListView) override;
};


class CTestShellCtrlsListView : public CView
{
public:
//Constructors / Destructors
  CTestShellCtrlsListView(const CTestShellCtrlsListView&) = delete;
  CTestShellCtrlsListView(CTestShellCtrlsListView&&) = delete;
  ~CTestShellCtrlsListView() = default; //NOLINT(modernize-use-override)

//Methods
  CTestShellCtrlsListView& operator=(const CTestShellCtrlsListView&) = delete;
  CTestShellCtrlsListView& operator=(CTestShellCtrlsListView&&) = delete;
  CTestShellCtrls2Doc* GetDocument();
  void OnDraw(CDC* pDC) noexcept override;
  BOOL PreCreateWindow(CREATESTRUCT& cs) override;
  BOOL OnPreparePrinting(CPrintInfo* pInfo) override;
  void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) noexcept override;
  void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo) noexcept override;
  void OnInitialUpdate() override;
  BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) override;

//Member variables
  CMyShellListCtrl m_ListCtrl;

protected:
//Constructors / Destructors
  CTestShellCtrlsListView() noexcept;

//Message handlers
  afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnSetFocus(CWnd* pOldWnd);
  afx_msg void OnToolsShowFiles();
  afx_msg void OnUpdateToolsShowFiles(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCDROM();
  afx_msg void OnUpdateToolsHideCDROM(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideFixed();
  afx_msg void OnUpdateToolsHideFixed(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRAMDisks();
  afx_msg void OnUpdateToolsHideRAMDisks(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRemovable();
  afx_msg void OnUpdateToolsHideRemovable(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRemote();
  afx_msg void OnUpdateToolsHideRemote(CCmdUI* pCmdUI);
  afx_msg void OnToolsFileNameMask();
  afx_msg void OnToolsHideHidden();
  afx_msg void OnUpdateToolsHideHidden(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideArchive();
  afx_msg void OnUpdateToolsHideArchive(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCompressed();
  afx_msg void OnUpdateToolsHideCompressed(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSystem();
  afx_msg void OnUpdateToolsHideSystem(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideTemporary();
  afx_msg void OnUpdateToolsHideTemporary(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideEncrypted();
  afx_msg void OnUpdateToolsHideEncrypted(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideOffline();
  afx_msg void OnUpdateToolsHideOffline(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReadOnly();
  afx_msg void OnUpdateToolsHideReadOnly(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReparsePoint();
  afx_msg void OnUpdateToolsHideReparsePoint(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSparse();
  afx_msg void OnUpdateToolsHideSparse(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideHidden2();
  afx_msg void OnUpdateToolsHideHidden2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideArchive2();
  afx_msg void OnUpdateToolsHideArchive2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCompressed2();
  afx_msg void OnUpdateToolsHideCompressed2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSystem2();
  afx_msg void OnUpdateToolsHideSystem2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideTemporary2();
  afx_msg void OnUpdateToolsHideTemporary2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideEncrypted2();
  afx_msg void OnUpdateToolsHideEncrypted2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideOffline2();
  afx_msg void OnUpdateToolsHideOffline2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReadOnly2();
  afx_msg void OnUpdateToolsHideReadOnly2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReparsePoint2();
  afx_msg void OnUpdateToolsHideReparsePoint2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSparse2();
  afx_msg void OnUpdateToolsHideSparse2(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowSharedFolders();
  afx_msg void OnUpdateToolsShowSharedFolders(CCmdUI* pCmdUI);
  afx_msg void OnRefresh();
  afx_msg void OnShellProperties();
  afx_msg void OnUpdateShellProperties(CCmdUI* pCmdUI);
  afx_msg void OnToolsAllowShellDefault();
  afx_msg void OnUpdateToolsAllowShellDefault(CCmdUI* pCmdUI);
  afx_msg void OnAutoRefresh();
  afx_msg void OnUpdateAutoRefresh(CCmdUI* pCmdUI);
  afx_msg void OnShellDefault();
  afx_msg void OnUpdateShellDefault(CCmdUI* pCmdUI);

  DECLARE_MESSAGE_MAP()
  DECLARE_DYNCREATE(CTestShellCtrlsListView)
};
