#include "stdafx.h"
#include "testShellCtrls2.h"
#include "MainFrm.h"
#include "testShellCtrls2Doc.h"
#include "testShellCtrls2View.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestShellCtrls2App, CWinApp) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
  ON_COMMAND(ID_APP_ABOUT, &CTestShellCtrls2App::OnAppAbout)
  ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
  ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
  ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

#pragma warning(suppress: 26426)
CTestShellCtrls2App theApp;

BOOL CTestShellCtrls2App::InitInstance()
{
  //Initialize Common Controls
  INITCOMMONCONTROLSEX InitCtrls;
  InitCtrls.dwSize = sizeof(InitCtrls);
  InitCtrls.dwICC = ICC_WIN95_CLASSES;
  InitCommonControlsEx(&InitCtrls);

  //Let the base class do its thing
  __super::InitInstance();

  //Settings will be stored in the registry
  SetRegistryKey(_T("PJ Naughter"));

  //Initialize OLE
  if (!AfxOleInit())
    return FALSE;

  //Register document templates
#pragma warning(suppress: 26403 26409)
  auto pDocTemplate{new CSingleDocTemplate(IDR_MAINFRAME, RUNTIME_CLASS(CTestShellCtrls2Doc),
                                           RUNTIME_CLASS(CMainFrame), RUNTIME_CLASS(CTestShellCtrlsTreeView))};
  if (pDocTemplate == nullptr)
    return FALSE;
  AddDocTemplate(pDocTemplate);

  //Parse command line for standard shell commands, DDE, file open
  CCommandLineInfo cmdInfo;
  ParseCommandLine(cmdInfo);

  //Dispatch commands specified on the command line
  if (!ProcessShellCommand(cmdInfo))
    return FALSE;
  m_pMainWnd->ShowWindow(SW_SHOW);
  m_pMainWnd->UpdateWindow();

  return TRUE;
}

class CAboutDlg : public CDialog
{
public:
//Constructors / Destructors
  CAboutDlg();
  CAboutDlg(const CAboutDlg&) = delete;
  CAboutDlg(CAboutDlg&&) = delete;
  ~CAboutDlg() = default; //NOLINT(modernize-use-override)

//Methods
  CAboutDlg& operator=(const CAboutDlg&) = delete;
  CAboutDlg& operator=(CAboutDlg&&) = delete;

protected:
//Member variables
  enum { IDD = IDD_ABOUTBOX };

//Methods
  void DoDataExchange(CDataExchange* pDX) override;

  DECLARE_MESSAGE_MAP()
};

#pragma warning(suppress: 26455)
CAboutDlg::CAboutDlg() : CDialog{CAboutDlg::IDD}
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
END_MESSAGE_MAP()

void CTestShellCtrls2App::OnAppAbout()
{
  CAboutDlg aboutDlg;
  aboutDlg.DoModal();
}
